<template lang="pug">
  .gpm-user-item
    .gpm-user-item__index
      | {{ index + 1 }}
    .gpm-user-item__basic-info
      .gpm-user-item__avatar
        img(:src="user.avatar")
      .gpm-user-item__name
        | {{ user.name }}
    .gpm-user-item__employee-code
      | {{ user.employeeCode }}
    .gpm-user-item__designation
      | {{ user.designation }}
    .gpm-user-item__phone-number
      | {{ user.phone }}
    .gpm-user-item__joining-date
      | {{ user.joiningDate | dateFormat }}
    .gpm-user-item__actions
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { IUser } from '@/api'

import format from 'date-fns/format'

@Component({
  filters: {
    dateFormat: (val: string) => format(new Date(val), 'MMM dd, uuuu')
  },
  props: {
    user: {
      type: Object,
      default: () => ({})
    },
    index: Number
  }
})
export default class GPMUserItem extends Vue {
  // Props
  readonly user!: IUser
  readonly index!: number
}

</script>

<style lang="scss">
.gpm-user-item {
  $root: &;

  display: flex;
  height: 56px;
  align-items: center;
  font-size: 14px;
  font-weight: bold;
  background-color: $white;
  color: #81899A;
  cursor: pointer;
  transition: box-shadow 200ms ease-in-out;

  &:hover {
    box-shadow: -1px -1px 30px 0 rgba($black, 0.2);
  }

  > * {
    flex: 1;
  }

  > #{$root}__index {
    flex: 0.5;
    text-align: center;
    color: rgba($black, 0.2);
  }

  > #{$root}__basic-info {
    flex: 1.5;
    display: flex;
    align-items: center;
  }

  &__avatar {
    margin-right: 16px;

    img {
      width: 32px;
      height: 32px;
      border-radius: 50%;
    }
  }

  &__employee-code,
  &__designation,
  &__phone-number,
  &__joining-date {
    text-align: center;
  }
}
</style>
